private import responser;
private import response;
private import request;
private import typical_responses;
private import log;
private import fileutil;

private import std.string;
private import std.file;

version (linux) {
	private import linux_listdir;
}

version (USE_DIRECTORY_RESPONSER) {

class DirectoryResponser : Responser {
	HttpResponse response(HttpRequest req) {
		char[] localFile = req.localFile;

//		if (!file_isdir(localFile)) return null;
		if (localFile[localFile.length-1] != '/') return null;

		HttpResponse res = new HttpResponse("HTTP/1.0 200 OK");

		if (!file_isdir(localFile)) {
			return TypicalResponses.resNotFound;
		}

/*
		DIR* dir = opendir(std.string.toStringz(req.localFile));

		if (dir === cast(DIR*)0) {
			return TypicalResponses.resNotFound;
		}
*/
		version (linux) {
			char[][] files = linux_listdir.listdir(req.localFile);
		}
		version (Win32) {
			char[][] files = listdir(req.localFile);
		}

		if (!files) {
			return TypicalResponses.resNotFound;
		}

		char[] listing =
			"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">"
			"<HTML>"
			"<HEAD>"
			"<TITLE>Index of /" ~ localFile ~ "</TITLE>"
			"</HEAD>"
			"<BODY>"
			"<H1>Index of /" ~ localFile ~ "</H1>"
			"<PRE>";

		files.sort;
		foreach (char[] name; files) {
			if (name == ".") continue;
			if (file_isdir(localFile ~ name)) name ~= "/";
			listing ~= "<A HREF=\"" ~ name ~ "\">" ~ name ~ "</A>\n";
		}
		listing ~= "</PRE></BODY></HTML>";

		res.messageBody = listing;
		res.header["Content-Type"] = "text/html";
		res.addDefaultHeader();

		return res;
	}
}


}

