template ArrayUtil(T_) {
	bool array_erase(inout T_[] a, T_ t) {
		for (int i = 0; i < a.length; i++) {
			if (a[i] === t) {
				a = a[0..i] ~ a[i+1..a.length];
				return true;
			}
		}
		return false;
	}
}

unittest {
	class C {}
	C[] cs;
	cs ~= new C;
	cs ~= new C;
	cs ~= new C;
	cs ~= null;
	instance ArrayUtil(C) AUC;
	assert(AUC.array_erase(cs, cs[2]));
	assert(AUC.array_erase(cs, cs[0]));
	assert(AUC.array_erase(cs, cs[0]));
	assert(AUC.array_erase(cs, null));
	assert(cs.length == 0);

	int[] ia;
	ia ~= 0;
	ia ~= 1;
	ia ~= 2;
	instance ArrayUtil(int) AUI;
	assert(AUI.array_erase(ia, 2));
	assert(ia[0] == 0);
	assert(ia[1] == 1);
	assert(AUI.array_erase(ia, 0));
	assert(ia[0] == 1);
	assert(AUI.array_erase(ia, 1));
	assert(cs.length == 0);
}
