private import std.stream;
private import std.string;
private import std.date;
private import std.c.stdlib;

private import myio;

class Log {
    private static char[] tostr2(int t) {
        if (t < 10) { return "0" ~ tostr(t); }
        else return tostr(t);
    }

	static bit errored = false;
	static void report(char[] tag, char[] msg) {
        d_time n = UTCtoLocalTime(getUTCtime());
        char[] t = tostr2(HourFromTime(n)) ~
            tostr2(MinFromTime(n)) ~ tostr2(SecFromTime(n));
		stdout.writeLine(t ~ " [" ~ tag ~ "] " ~ msg);
	}
	static void error(char[] msg) {
		report("ERROR", msg);
		errored = true;
		exit(1);
	}
	static void warn(char[] msg) {
		report("WARN", msg);
	}
	static void info(char[] msg) {
		report("INFO", msg);
	}
	static void dbg(char[] msg) {
		debug {
			report("DBG", msg);
		}
	}
	static void dbg(int msg) {
		debug {
			report("DBG", std.string.toString(msg));
		}
	}
	static bit isErrored() {
		return errored;
	}
}
