private import responser;
private import typical_responses;
private import response;
private import request;
private import log;
private import attohttpd;
private import sockutil;
private import myio;

private import socket;

private import std.string;
private import std.conv;

version (USE_PROXY_RESPONSER) {

class ProxyResponser : Responser {
public:
	this() {
        timeout_ = AttoHttpd.self.conf.get("ProxyTimeout").integer * 1000000;
    }

    HttpResponse error(char[] msg) {
        Log.warn(msg);
        return TypicalResponses.resProxyError(msg);
    }

	override HttpResponse response(HttpRequest req) {
		with (req) {
			if (!requestHost) return null;

            int port;
            InternetAddress server;
            try {
                port = (requestPort) ? toInt(requestPort) : 80;
                server = new InternetAddress(requestHost, port);
            }
            catch (SocketException se) {
				return error(requestHost ~ ":" ~ tostr(port) ~
                             ": cannot resolve hostname: " ~ se.toString());
			}

            if ((server.addr == AttoHttpd.self.address.addr ||
                 server.addr == LOCALHOST) &&
                server.port == AttoHttpd.self.address.port)
            {
                return null;
            }

            Socket sock;
            try {
                sock = new Socket(AddressFamily.INET, SocketType.STREAM,
                                  ProtocolType.IP);
                sock.connect(server);
            }
            catch (SocketException se) {
				return error(requestHost ~ ":" ~ tostr(port) ~
                             ": connection failed: " ~ se.toString());
			}

            SocketSet sockset;
            try {
                sockset = new SocketSet(1);
            }
            catch (SocketException se) {
				return error("cannot create socket set: " ~ se.toString());
			}
            sockset.add(sock);

            safeSend(sock, all);

			static const int BUFSIZE = 1024 * 1024;
			static char buf[BUFSIZE];
			char[] data = "";

            for (;;) {
                if (Socket.select(sockset, null, null, timeout_)) {
                    int len = sock.receive(buf);
                    if (len <= 0) {
                        break;
                    }
                    else {
                        data ~= buf[0..len];
                    }
                }
                else {
                    sock.shutdown(SocketShutdown.BOTH);
                    sock.close();
                    sockset.reset();
                    return error("proxy request timeouted");
                }
			}
            
            sock.shutdown(SocketShutdown.BOTH);
            sock.close();

			return HttpResponse.createFromFullResponse(data);
		}
	}

    private int timeout_;
}

}

