import std.conv;
import std.stream;
import std.string;

import log;

version (USE_RC_RESPONSER) {

class Rc {
public:
	this(char[] sep) {
		sep_ = sep;
	}

	this() {
		this(" ");
	}

	void addDefault() {
	}
	void addResourceFile() {
		addResourceFile("cave.rc");
	}
	void addResourceFile(char[] file) {
		auto File input;
		try {
			input = new File(file);
		}
		catch (Error e) {
			Log.error(e.toString());
		}

		if (input.eof()) {
			Log.error(file ~ ": file not found");
		}

		while (!input.eof()) {
			char[] line = input.readLine();
			if (line.length == 0 || line[0] == '#') continue;
			char[][] tok = split(line, sep_);
			if (tok.length < 2) {
				Log.warn(file ~  ": resource file broken. (" ~ line ~ ")");
			}

//			int valIndex = (tok[1] == sep_) ? 2 : 1;
			int valIndex = 1;

			char[] val = join(tok[valIndex..tok.length], sep_);

			set(tok[0], val);
		}
	}
	void addArgument(char args[][]) {
	}

public:
	bit hasKey(char[] key) {
		return rc_[key] !== null;
	}

	char[] get(char[] key) {
		return rc_[key];
	}
	int getInt(char[] key) {
		return toInt(get(key));
	}
	float getFloat(char[] key) {
		return atof(get(key));
	}

	void set(char[] key, char[] val) {
		rc_[key] = val;
	}

	char[][] keys() {
		return rc_.keys;
	}

	void dump(Stream s) {
		foreach (char[] k; rc_.keys) {
			s.writeLine(k ~ sep_ ~ rc_[k]);
		}
	}

	void dump(char[] filename) {
		auto File f = new File(filename, FileMode.Out);
		dump(f);
		f.close();
	}

private:
	char[][char[]] rc_;
	char[] sep_;

};

import std.stream;

unittest {
	void doAssert(bit b) {
		if (!b) {
			stdout.writeLine("assert failure");
		}
	}

	auto Rc rc = new Rc();
	rc.set("hoge", "huga");
	doAssert("huga" == rc.get("hoge"));
	doAssert(null == rc.get("huga"));
}

}
