private import responser;
private import response;
private import request;
private import typical_responses;
private import embedded_cgi;
private import rc;
private import fileutil;

private import std.string;

version (USE_RC_RESPONSER) {

class RcResponser : Responser {
	this(char[] sep) { sep_ = sep; }

	HttpResponse response(HttpRequest req) {
		if (req.suffix != "rc") {
			return null;
		}

		if (!file_canread(req.localFile)) {
			return TypicalResponses.resNotFound;
		}

		rcFile_ = req.localFile;

		req.localFile ~= ".html";
		req.suffix = "html";

		rc_ = new Rc(sep_);
		rc_.addResourceFile(rcFile_);

		if (!file_canread(req.localFile)) {
			return TypicalResponses.resNotFound;
		}

		char[][char[]] params = getCgiParams(req);

		if (params.length == 0) return null;

		foreach (char[] key; params.keys) {
			char[][] ops = std.string.split(key, ";");
			if (ops[0] == "set") {
				rc_.set(ops[1], params[key]);
			}
		}

		rc_.dump(rcFile_);

		return null;
	}

private:
	char[] rcFile_;
	Rc rc_;
	char[] sep_;

}

}
