private import myio;

private import std.string;

class HttpResponse {
public:
	this() {}

	this(char[] sl) {
		statusLine = sl;
	}

    static HttpResponse createFromFullResponse(char[] data) {
        char[][] lines = split(data, "\r\n");

        HttpResponse res = new HttpResponse(lines[0]);

        int i;
        for (i = 1; ; i++) {
            if (lines[i] == "") break;

            int f = find(lines[i], ": ");
            res.header[tolower(lines[i][0..f])] =
                lines[i][f+2..lines[i].length];
        }
        res.messageBody = join(lines[i+1..lines.length], "\r\n");

        return res;
    }

	void addDefaultHeader() {
		header["Connection"] = "close";
		if (messageBody.length > 0) {
			header["Content-Length"] = tostr(messageBody.length);
		}
	}

	char[] toString() {
        if (all) return all;

        char[] crlf = "\r\n";

        all = statusLine ~ crlf;

        char[][] keys = header.keys;

        foreach (char[] k; header.keys) {
            all ~= k ~ ": " ~ header[k] ~ crlf;
        }

        all ~= crlf ~ messageBody;

        return all;
	}

public:
    char[] all;
	char[] statusLine;
	char[][char[]] header;
	char[] messageBody;

}

