private import filter;
private import request;
private import response;
private import typical_responses;
private import attohttpd;
private import log;
private import bogoyaml;
private import myio;

private import std.regexp;
private import std.string;

version (USE_RESPONSE_FILTER) {

class ResponseFilter : Filter {
    class Rule {
    public:
        RegExp uri;
        RegExp search;
        char[] replace;
    }

    this() {
        YamlHolder conf = AttoHttpd.self.conf;
        YamlHolder[] rules = conf.get("ResponseFilter").array;
        foreach (YamlHolder r; rules) {
            Rule rule = new Rule();
            rule.uri = new RegExp(r.get("uri").str(), "g");
            rule.search = new RegExp(r.get("search").str(), "gm");
            rule.replace = r.get("replace").str;
            rules_ ~= rule;
        }
    }

	bool filter(HttpRequest req, inout HttpResponse res) {
        if (!req.requestHost) return true;

        int num = 0;

        foreach (Rule rule; rules_) {
            with (rule) {
                if (uri.search(req.url) >= 0) {
                    res.messageBody = search.replace(res.messageBody, replace);
                    num++;
                }
            }
        }

        if (num) Log.info(tostr(num) ~ " rules filter applied");

        return true;
	}

private:
    Rule[] rules_;

}

}
