private import responser;
private import response;
private import request;
private import bogoyaml;
private import typical_responses;
private import embedded_cgi;
private import ypath;
private import fileutil;
private import log;

private import std.string;

version (USE_YAML_RESPONSER) {

class YamlResponser : Responser {
	HttpResponse response(HttpRequest req) {
		if (req.suffix != "yml") {
			return null;
		}

		if (!file_canread(req.localFile)) {
			return TypicalResponses.resNotFound;
		}

		char[] yamlFile = req.localFile;

		req.localFile ~= ".html";
		req.suffix = "html";

		YamlHolder yaml = bogoyaml.yamlLoad(yamlFile);

		if (!file_canread(req.localFile)) {
			return TypicalResponses.resNotFound;
		}

		char[][char[]] params = getCgiParams(req);

		if (params.length == 0) return null;

		foreach (char[] key; params.keys) {
			char[][] ops = std.string.split(key, ";");
			if (ops[0] == "set") {
				try {
					YamlHolder y = getYpath(yaml, ops[1]);
					y.str = params[key];
				}
				catch (YamlError ye) {
					Log.warn(yamlFile ~ ": " ~ ops[1] ~ " not found");
				}
			}
		}

		yaml.dump(yamlFile);

		return null;
	}
}

}
